 Mailman/Archiver/Archiver.py       |   29 +++--
 Mailman/Archiver/HyperArch.py      |   18 ++-
 Mailman/Archiver/pipermail.py      |    7 +
 Mailman/Bouncers/BouncerAPI.py     |   12 +-
 Mailman/Bouncers/DSN.py            |   10 -
 Mailman/Bouncers/Qmail.py          |   18 ---
 Mailman/Bouncers/SMTP32.py         |    8 -
 Mailman/Bouncers/SimpleMatch.py    |   58 ++--------
 Mailman/Bouncers/SimpleWarning.py  |   12 --
 Mailman/Cgi/admin.py               |    5 
 Mailman/Cgi/admindb.py             |    2 
 Mailman/Cgi/confirm.py             |    2 
 Mailman/Cgi/edithtml.py            |    2 
 Mailman/Cgi/listinfo.py            |    2 
 Mailman/Cgi/options.py             |    2 
 Mailman/Cgi/private.py             |    6 -
 Mailman/Cgi/rmlist.py              |    5 
 Mailman/Cgi/roster.py              |    2 
 Mailman/Cgi/subscribe.py           |    2 
 Mailman/Defaults.py.in             |    6 -
 Mailman/Deliverer.py               |    5 
 Mailman/Gui/Digest.py              |    3 
 Mailman/Gui/General.py             |    2 
 Mailman/Gui/Topics.py              |    5 
 Mailman/HTMLFormatter.py           |    3 
 Mailman/Handlers/Cleanse.py        |   11 +
 Mailman/Handlers/CookHeaders.py    |   14 +-
 Mailman/Handlers/Decorate.py       |   15 +-
 Mailman/Handlers/Hold.py           |    3 
 Mailman/Handlers/SMTPDirect.py     |    2 
 Mailman/Handlers/Scrubber.py       |   24 ++--
 Mailman/Handlers/SpamDetect.py     |   19 +--
 Mailman/Handlers/ToArchive.py      |   13 +-
 Mailman/Handlers/ToDigest.py       |   17 ++
 Mailman/ListAdmin.py               |    4 
 Mailman/MTA/Manual.py              |    2 
 Mailman/MTA/Postfix.py             |  127 ++++++++++++++++++----
 Mailman/MTA/Utils.py               |   18 +--
 Mailman/MailList.py                |   53 ++++++---
 Mailman/Message.py                 |    2 
 Mailman/Queue/ArchRunner.py        |    2 
 Mailman/Queue/BounceRunner.py      |   21 ---
 Mailman/Queue/NewsRunner.py        |    8 -
 Mailman/SecurityManager.py         |    8 +
 Mailman/Site.py                    |   78 ++++++++++---
 Mailman/Utils.py                   |   49 ++++++++
 Mailman/Version.py                 |    6 -
 Mailman/i18n.py                    |   15 --
 NEWS                               |   34 -----
 bin/cleanarch                      |    7 -
 bin/list_lists                     |    7 -
 bin/mailmanctl                     |    9 -
 bin/newlist                        |   22 +++
 bin/qrunner                        |   16 --
 bin/show_qfiles                    |   23 ---
 bin/update                         |    1 
 contrib/README.mmdsr               |   64 ++++-------
 contrib/mmdsr                      |  118 +-------------------
 messages/es/LC_MESSAGES/mailman.po |  213 ++++++++++++++++++++-----------------
 misc/Makefile.in                   |    7 -
 tests/test_bounces.py              |   44 +------
 61 files changed, 673 insertions(+), 629 deletions(-)

diff -pru mailman-cvs-2.1-maint/bin/cleanarch mailman-2.1.7.cg/bin/cleanarch
--- mailman-cvs-2.1-maint/bin/cleanarch	2006-01-22 21:34:20.000000000 +0100
+++ mailman-2.1.7.cg/bin/cleanarch	2005-08-27 03:40:16.000000000 +0200
@@ -1,6 +1,6 @@
 #! @PYTHON@
 
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2003 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -14,8 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Clean up an .mbox archive file.
 
@@ -60,7 +59,7 @@ cre = re.compile(mailbox.UnixMailbox._fr
 # From RFC 2822, a header field name must contain only characters from 33-126
 # inclusive, excluding colon.  I.e. from oct 41 to oct 176 less oct 072.  Must
 # use re.match() so that it's anchored at the beginning of the line.
-fre = re.compile(r'[\041-\071\073-\176]+')
+fre = re.compile(r'[\041-\071\073-\0176]+')
 
 
 
diff -pru mailman-cvs-2.1-maint/bin/list_lists mailman-2.1.7.cg/bin/list_lists
--- mailman-cvs-2.1-maint/bin/list_lists	2005-08-27 03:40:16.000000000 +0200
+++ mailman-2.1.7.cg/bin/list_lists	2006-02-22 10:28:36.000000000 +0100
@@ -108,13 +108,16 @@ def main():
     if not bare:
         print len(mlists), _('matching mailing lists found:')
 
-    format = '%%%ds - %%.%ds' % (longest, 77 - longest)
+    format = '%%%ds%%s - %%.%ds' % (longest, 77 - longest)
     for mlist in mlists:
         if bare:
             print mlist.internal_name()
         else:
             description = mlist.description or _('[no description available]')
-            print '   ', format % (mlist.real_name, description)
+            if '@' in mlist.internal_name():
+                print '   ', format % (mlist.real_name, '@', description)
+            else:
+                print '   ', format % (mlist.real_name, ' ', description)
 
 
 
diff -pru mailman-cvs-2.1-maint/bin/mailmanctl mailman-2.1.7.cg/bin/mailmanctl
--- mailman-cvs-2.1-maint/bin/mailmanctl	2006-02-05 05:45:09.000000000 +0100
+++ mailman-2.1.7.cg/bin/mailmanctl	2005-08-27 03:40:16.000000000 +0200
@@ -1,6 +1,6 @@
 #! @PYTHON@
 
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2004 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -14,8 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Primary start-up and shutdown script for Mailman's qrunner daemon.
 
@@ -419,8 +418,8 @@ def main():
         os.setsid()
         # Instead of cd'ing to root, cd to the Mailman installation home
         os.chdir(mm_cfg.PREFIX)
-        # Set our file mode creation umask
-        os.umask(007)
+        # Clear our file mode creation umask
+        os.umask(0)
         # I don't think we have any unneeded file descriptors.
         #
         # Now start all the qrunners.  This returns a dictionary where the
diff -pru mailman-cvs-2.1-maint/bin/newlist mailman-2.1.7.cg/bin/newlist
--- mailman-cvs-2.1-maint/bin/newlist	2005-08-27 03:40:16.000000000 +0200
+++ mailman-2.1.7.cg/bin/newlist	2006-03-10 12:52:10.000000000 +0100
@@ -73,6 +73,9 @@ where `mydom.ain' is the mail domain nam
 urlhost is not in the virtual host list, then mm_cfg.DEFAULT_EMAIL_HOST will
 be used for the email interface.
 
+NDIM XXX Ooops. How to keep this backward compatibility below? The
+vhost branch newlist is currently following a different model.
+
 For backward compatibility, you can also specify the domain to create your
 new list in by spelling the listname like so:
 
@@ -154,12 +157,23 @@ def main():
     else:
         listname = raw_input(_('Enter the name of the list: '))
     listname = listname.lower()
-
+    
     if '@' in listname:
         # note that --urlhost and --emailhost have precedence
-        listname, domain = listname.split('@', 1)
-        urlhost = urlhost or domain
-        emailhost = emailhost or mm_cfg.VIRTUAL_HOSTS.get(domain, domain)
+        firstname, domain = listname.split('@', 1)
+        urlhost = urlhost or ('lists.%s' % domain) # TODO: Not configurable yet
+        if not emailhost:
+            emailhost = domain
+        else:
+            usage(1, _('You cannot use an email host different from the domain part of the list name.'))
+        if not mm_cfg.VIRTUAL_HOSTS.has_key(urlhost):
+            _urlhost = repr(urlhost)
+            _emailhost = repr(emailhost)
+            usage(1, _('The Mailman config file lacks a line mapping urlhost to emailhost:\n  add_virtualhost(%(_urlhost)s,\n                  %(_emailhost)s)'))
+    else:
+        # Handle site wide lists (non-vhost lists, i.e. without '@' in their name)
+        # in the traditional manner.
+        pass
 
     urlhost = urlhost or mm_cfg.DEFAULT_URL_HOST
     host_name = emailhost or \
diff -pru mailman-cvs-2.1-maint/bin/qrunner mailman-2.1.7.cg/bin/qrunner
--- mailman-cvs-2.1-maint/bin/qrunner	2006-01-19 02:07:40.000000000 +0100
+++ mailman-2.1.7.cg/bin/qrunner	2005-08-27 03:40:16.000000000 +0200
@@ -1,6 +1,6 @@
 #! @PYTHON@
 
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -14,8 +14,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Run one or more qrunners, once or repeatedly.
 
@@ -67,9 +66,6 @@ Options:
 
 runner is required unless -l or -h is given, and it must be one of the names
 displayed by the -l switch.
-
-Note also that this script should be started up from mailmanctl as a normal
-operation.  It is only useful for debugging if it is run separately.
 """
 
 import sys
@@ -88,6 +84,8 @@ COMMASPACE = ', '
 # Flag which says whether we're running under mailmanctl or not.
 AS_SUBPROC = 0
 
+LogStdErr('error', 'qrunner', manual_reprime=0)
+
 
 
 def usage(code, msg=''):
@@ -214,12 +212,6 @@ def main():
     if len(runners) == 0:
         usage(1, _('No runner name given.'))
 
-    # Before we startup qrunners, we redirect the stderr to mailman syslog.
-    # We assume !AS_SUBPROC is running for debugging purpose and don't
-    # log errors in mailman logs/error but keep printing to stderr.
-    if AS_SUBPROC:
-        LogStdErr('error', 'qrunner', manual_reprime=0, tee_to_real_stderr=0)
-
     # Fast track for one infinite runner
     if len(runners) == 1 and not once:
         qrunner = make_qrunner(*runners[0])
diff -pru mailman-cvs-2.1-maint/bin/show_qfiles mailman-2.1.7.cg/bin/show_qfiles
--- mailman-cvs-2.1-maint/bin/show_qfiles	2006-03-10 11:36:50.000000000 +0100
+++ mailman-2.1.7.cg/bin/show_qfiles	2003-09-22 04:29:50.000000000 +0200
@@ -1,21 +1,4 @@
 #! @PYTHON@
-#
-# Copyright (C) 2006 by the Free Software Foundation, Inc.
-#
-# This program is free software; you can redistribute it and/or
-# modify it under the terms of the GNU General Public License
-# as published by the Free Software Foundation; either version 2
-# of the License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
 
 """Show the contents of one or more Mailman queue files.
 
@@ -81,11 +64,7 @@ def main():
         fp = open(filename)
         if filename.endswith(".pck"):
             msg = load(fp)
-            data = load(fp)
-            if data.get('_parsemsg'):
-                sys.stdout.write(msg)
-            else:
-                sys.stdout.write(msg.as_string())
+            sys.stdout.write(msg.as_string())
         else:
             sys.stdout.write(fp.read())
 
diff -pru mailman-cvs-2.1-maint/bin/update mailman-2.1.7.cg/bin/update
--- mailman-cvs-2.1-maint/bin/update	2005-08-27 03:40:16.000000000 +0200
+++ mailman-2.1.7.cg/bin/update	2006-03-06 12:12:27.000000000 +0100
@@ -344,6 +344,7 @@ script.
     #
     tmpl_dir = os.path.join(mm_cfg.PREFIX, "templates")
     list_dir = os.path.join(mm_cfg.PREFIX, "lists")
+    # NDIM XXX internal_name
     b4_tmpl_dir = os.path.join(tmpl_dir, mlist._internal_name)
     new_tmpl_dir = os.path.join(list_dir, mlist._internal_name)
     if os.path.exists(b4_tmpl_dir):
diff -pru mailman-cvs-2.1-maint/contrib/mmdsr mailman-2.1.7.cg/contrib/mmdsr
--- mailman-cvs-2.1-maint/contrib/mmdsr	2006-01-29 18:40:36.000000000 +0100
+++ mailman-2.1.7.cg/contrib/mmdsr	2005-12-25 04:21:56.000000000 +0100
@@ -112,43 +112,6 @@
 #		Adrian discovered that there was a log file format
 #		change between Mailman 2.1.5 and 2.1.6, which broke
 #		hourly statistics.
-#
-# 0.0.13	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Mon Dec 26 05:54:27 CET 2005
-#		Bugs found by Tom G. Christensen (tgc99):
-#		> ps output on solaris is full of whitespace but a further
-#		> echo get's rid of it.
-#		> The lines in the smtp log are sometimes broken up by a
-#		> newline (right before the msgid) which throws of the
-#		> summary. Piping it through sed first will rejoin the broken
-#		> lines.
-#		> Use $AWK instead of awk.
-#		Enhancements from Mark Sapiro:
-#		> The vette log summary lists posts held for moderation
-#		> individually under "Other Errors:". The following patch
-#		> (watch out for wrapped lines) summarizes them by list instead.
-#
-# 0.0.14	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Thu Dec 29 08:17:38 CET 2005
-#		Added code to check /usr/local/mailman/data for
-#		moderation hold queue
-#
-# 0.0.15	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Thu Jan 26 02:39:38 CET 2006
-#		Tweaked display of summary data in the "smtp-failure" log,
-#		and "other" category in the "vette" log, so as to reduce
-#		the spewage when things go wonky, mostly by removing
-#		unique-ifying data like message-id or sender address.
-#		Also tweaked moderation queue information, to tell us
-#		how many Python pickle files are in the data directory,
-#		as opposed to just doing a directory listing and skipping
-#		the files in the middle if there are too many -- now we
-#		know how many are being skipped.
-#
-# 0.0.16	Update by Brad Knowles <brad@stop.mail-abuse.org>
-#		Updated on: Sun Jan 29 11:45:58 CET 2006
-#		Mark found a couple of typos that I somehow let slip
-#		through.  Thanks!
 
 ###############################################################################
 # Set up locations of standard commands, directories, etc....
@@ -193,19 +156,9 @@ QUEUEDIR="/usr/local/mailman/qfiles"
 LOGDIR="/usr/local/mailman/logs"
 
 ###############################################################################
-# Mailman data directory
-###############################################################################
-DATADIR="/usr/local/mailman/data"
-
-###############################################################################
 # Maximum number of subdirectory entries to display in report
 ###############################################################################
-MAX_QUEUE_LINES=20
-
-###############################################################################
-# Maximum number of moderation queue pickle files to display in report
-###############################################################################
-MAX_DATA_LINES=100
+MAX_LINES=20
 
 ###############################################################################
 # Mailman Log files to check for errors.
@@ -229,8 +182,8 @@ SUBDIRS="archive bounces commands in new
 # Specify sender address for report.  Not used if recipient list is empty.
 ###############################################################################
 
-SENDER="INSERT.YOUR.SENDER.ADDRESS@HERE"
-RCPTS="INSERT.YOUR.RECIPIENTS.ADDRESSES@HERE"
+SENDER="put@your.address.here"
+RCPTS="put@the.address.of,your@recipients.here"
 
 ###############################################################################
 # If you run this program in cron at 23:59:00, you need to sleep sixty
@@ -250,8 +203,7 @@ SLEEPTIME=60
 #	there is an easier cross-platform way to do it, please let me know.
 ###############################################################################
 
-GRABUID=`$PS -o user -p $$ | $TAIL -1`
-MYUID=`echo $GRABUID`
+MYUID=`$PS -o user -p $$ | $TAIL -1`
 RUNAS="mailman"
 
 ###############################################################################
@@ -302,9 +254,9 @@ do
     $TOUCH $TMPLOG
     echo "Log file: $LOG" >> $TMP
     echo "==============================" >> $TMP
+    $GREP -si "^$DAY [0-9][0-9:]* $YEAR" $LOGDIR/$LOG >> $TMPLOG
 
     if [ -f "$LOGDIR/${LOG}" ] ; then
-    $SED -e :a -e '$!N;s/\n //;ta' -e 'P;D' $LOGDIR/$LOG | $GREP -si "^$DAY [0-9][0-9:]* $YEAR" >> $TMPLOG
 
 	if [ "${LOG}" = "post" ] ; then
 
@@ -312,7 +264,7 @@ do
 	    echo "Hourly Summary of Posts" >> $TMP
 	    echo "-----------------------" >> $TMP
 
-	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.*$//' $TMPLOG | $UNIQ -c | $SORT -n +1 | $AWK '{ printf( "%8d  %02d:00-%02d:59\n", $1, $2, $2 ) }' >> $TMP
+	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.*$//' $TMPLOG | $UNIQ -c | $SORT -n +1 | awk '{ printf( "%8d  %02d:00-%02d:59\n", $1, $2, $2 ) }' >> $TMP
 
 	    echo "" >> $TMP
 	    echo "Post Count by List" >> $TMP
@@ -343,7 +295,7 @@ do
 	    echo "" >> $TMP
 	    echo "Hourly Summary of Messages Sent" >> $TMP
 	    echo "-------------------------------" >> $TMP
-	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.* for / /' -e 's/ recips,.*$//' $TMPLOG | $AWK '{ val=int($1); sum[val]+=$2 } END { for (i=0; i<24; i++) { printf "%8d %02d:00-%02d:59\n", sum[i], i, i } }' >> $TMP
+	    $SED -e 's/^[A-Z][a-z][a-z] *[0-9]* //' -e 's/:.* for / /' -e 's/ recips,.*$//' $TMPLOG | awk '{ val=int($1); sum[val]+=$2 } END { for (i=0; i<24; i++) { printf "%8d %02d:00-%02d:59\n", sum[i], i, i } }' >> $TMP
 
 	else
 
@@ -464,18 +416,9 @@ do
 	    $GREP -i 'Posting to a moderated newsgroup' $TMPLOG | $AWK '{ print $6 }' | $SORT | $UNIQ -c | $SORT -nr >> $TMP
 
 	    echo "" >> $TMP
-	    echo "Post to moderated list (by list):" >> $TMP
-	    echo "------------------------------" >> $TMP
-	    $GREP -i 'Post to moderated list' $TMPLOG | $AWK '{ print $6 }' | $SORT | $UNIQ -c | $SORT -nr >> $TMP
-
-	    echo "" >> $TMP
 	    echo "Other Errors:" >> $TMP
 	    echo "------------------------------" >> $TMP
-	    $EGREP -vi '(Post by non-member|suspicious header|message approved|Discarded posting|bulk message discarded|junk message discarded|Message has implicit destination|Posting to a moderated newsgroup|Post to moderated list|Message discarded, msgid)' $TMPLOG | $SED -e 's/^.* ([0-9]*) //' -e 's/, message-id=<[^> ]*>:/:/' | $SORT | $UNIQ -c | $SORT -nr >> $TMP 
-
-	elif [ "${LOG}" = "smtp-failure" ] ; then
-
-	    $SED 's/^.* ([0-9]*) //' $TMPLOG | $SED 's/delivery to [^@ ]*@[^@ ]* failed with code/delivery failed with code/g' | $SORT | $UNIQ -c | $SORT -nr >> $TMP 
+	    $EGREP -vi '(Post by non-member|suspicious header|message approved|Discarded posting|bulk message discarded|junk message discarded|Message has implicit destination|Posting to a moderated newsgroup|Message discarded, msgid)' $TMPLOG | $SED 's/^.* ([0-9]*) //' | $SORT | $UNIQ -c | $SORT -nr >> $TMP 
 
 	else
 
@@ -503,7 +446,7 @@ do
     $RM -f $TMPLOG
     $TOUCH $TMPLOG
     $LS -la $DIR >> $TMPLOG
-    LINES=`$WC -l < $TMPLOG`
+    LINES=`wc -l < $TMPLOG`
     LINES=`expr $LINES - 3`
 
     echo "Subdirectory: $DIR" >> $TMP
@@ -511,12 +454,12 @@ do
     echo "Entries: $LINES" >> $TMP
     echo "------------------------------" >> $TMP
 
-    if [ $LINES -le $MAX_QUEUE_LINES ] ; then
+    if [ $LINES -le $MAX_LINES ] ; then
     	$CAT $TMPLOG >> $TMP
     else
     	$HEAD $TMPLOG >> $TMP
 	echo "" >> $TMP
-	echo "	More than $MAX_QUEUE_LINES total entries, skipping ..." >> $TMP
+	echo "	More than $MAX_LINES total entries, skipping ..." >> $TMP
 	echo "" >> $TMP
     	$TAIL $TMPLOG >> $TMP
     fi
@@ -524,45 +467,6 @@ do
 
 done
 
-echo "******************************" >> $TMP
-echo "Data Directory Contents" >> $TMP
-echo "	(Python pickle files only)" >> $TMP
-echo "******************************" >> $TMP
-
-cd $DATADIR
-
-$RM -f $TMPLOG
-$TOUCH $TMPLOG
-$LS -la | $GREP -i '\.pck$' >> $TMPLOG
-LINES=`$WC -l < $TMPLOG`
-
-echo "Python pickle files: $LINES" >> $TMP
-echo "==============================" >> $TMP
-echo "" >> $TMP
-
-if [ $LINES -le $MAX_DATA_LINES ] ; then
-    $CAT $TMPLOG >> $TMP
-else
-    $HEAD $TMPLOG >> $TMP
-    echo "" >> $TMP
-    echo "	More than $MAX_DATA_LINES total entries, skipping ..." >> $TMP
-    echo "" >> $TMP
-    $TAIL $TMPLOG >> $TMP
-fi
-echo "" >> $TMP
-
-echo "******************************" >> $TMP
-echo "Moderation Queue Summary" >> $TMP
-echo "******************************" >> $TMP
-echo "" >> $TMP
-
-$AWK '{ print $NF }' $TMPLOG | $GREP -i '^heldmsg-' | $SED -e 's/^heldmsg-//' -e 's/-[0-9]*\.pck$//' | $SORT | $UNIQ -c | $SORT -nr >> $TMP
-echo "" >> $TMP
-
-###############################################################################
-# Okay, we're done with all the code stuff, now handle the output
-###############################################################################
-
 if [ "${RCPTS}x" != "x" ] ; then
     $SENDMAIL -t -f$SENDER < $TMP
 else
diff -pru mailman-cvs-2.1-maint/contrib/README.mmdsr mailman-2.1.7.cg/contrib/README.mmdsr
--- mailman-cvs-2.1-maint/contrib/README.mmdsr	2006-01-29 13:55:26.000000000 +0100
+++ mailman-2.1.7.cg/contrib/README.mmdsr	2005-12-30 19:58:15.000000000 +0100
@@ -5,41 +5,31 @@ for mailman.  It was initially posted at
 <http://sourceforge.net/tracker/index.php?func=detail&aid=1123383&group_id=103&atid=300103>
 which see for possible patches and other enhancements.
 
-Here goes the original mmdsr.readme by Brad ...
+It is intended that there will be a 'cleaner', more complete readme file in
+the future.  In the interim, here are Brad's original comments.
 
-========================================================================
-This is a basic Bourne shell script that I quickly hacked together for
-my own purposes, designed to be fired off at 23:59 every night, going
-through a variety of Mailman log files looking for entries specific
-to that date, summarizing the activities, and indicating problems or
-certain types of activity that might be of interest to someone trying
-to administer the server.
-
-It also does an "ls -la" of /usr/local/mailman/qfiles/*, so that you
-can see what is in the queue at the time of the execution of the script.
-
-This daily report will get e-mailed to the admin, or posted to a "reports"
-mailing list, where they can be archived and kept for future reference.
-If you don't define an address where the output e-mail should be sent,
-it will instead be printed to the standard output (thus allowing you to
-do something else with it).
-
-
-Once I'd gone through a few revisions of my own on this tool, I
-thought that I would release the code to the public and get comments
-and suggestions from others in the Mailman community.  This program is
-currently being used actively on the mail servers for python.org (where
-the mailman-users and other Mailman-related mailing lists are hosted),
-as well as many others.
-
-Note that this script needs to be configured once to know where standard
-commands are located, where log files are kept, etc... (see the top
-500 lines or so of the script), but after that you don't need to feed
-it any input, or capture the output to be sent anywhere.  This script
-takes care of all of that.  All you should need to do is to call this
-script from a cron job at 23:59 (local time) every night.
-
-
-When looking at this script, perhaps during configuration, please keep
-in mind that it is heavily commented at the top, and everything should
-hopefully be self-evident.
+I quickly whacked together a Daily Status Report script for Mailman (using
+Bourne shell, not Python ;), and thought that other folks might be interested
+in seeing it.
+
+The basic concept is a program that gets fired off at 23:59 every night, and
+goes through a variety of log files looking for entries specific to that date,
+and indicating problems or certain types of activity that might be of interest
+to someone trying to administer the server.  It also does an "ls -la" of
+/usr/local/mailman/qfiles/*, so that you can see what is in the queue at the
+time of the running of the script.
+
+My concept was that this daily report would get e-mailed to the admin, or
+posted to a "reports" mailing list, where they could be archived and kept for
+future reference.
+
+The script does not (yet) do any statistics calculations, although it should
+be relatively easy to hack together some basic stats using awk, sort, etc....
+
+Anyway, I thought I'd share it and let folks take a look at it, and if anyone
+has any recommended improvements, we can incorporate those and share them back
+out with everyone.
+
+The code is written under a BSD-style license, so if you don't want to
+contribute any changes back to me, that's okay. Of course, I would prefer that
+you did, but I leave the choice up to you.
diff -pru mailman-cvs-2.1-maint/Mailman/Archiver/Archiver.py mailman-2.1.7.cg/Mailman/Archiver/Archiver.py
--- mailman-cvs-2.1-maint/Mailman/Archiver/Archiver.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Archiver/Archiver.py	2006-03-08 18:05:58.000000000 +0100
@@ -24,7 +24,6 @@ archival.
 
 import os
 import errno
-import traceback
 import re
 from cStringIO import StringIO
 
@@ -46,6 +45,17 @@ except NameError:
 
 def makelink(old, new):
     try:
+        # Before symlinking, make sure that the directory where the
+        # symlink will be created exists.
+        omask = os.umask(0)
+        try:
+            try:
+                os.makedirs(os.path.split(new)[0], 02775)
+            except OSError, e:
+                if e.errno <> errno.EEXIST:
+                    raise
+        finally:
+            os.umask(omask)
         os.symlink(old, new)
     except OSError, e:
         if e.errno <> errno.EEXIST:
@@ -80,9 +90,17 @@ class Archiver:
         #             listname.mbox
         #         listname/
         #             lots-of-pipermail-stuff
+        #         domain.com/
+        #             listname.mbox/
+        #                 listname.mbox
+        #             listname/
+        #                 lots-of-pipermail-stuff
         #     public/
         #         listname.mbox@ -> ../private/listname.mbox
         #         listname@ -> ../private/listname
+        #         domain.com/
+        #             listname.mbox@ -> ../../private/listname.mbox
+        #             listname@ -> ../../private/listname
         #
         # IOW, the mbox and pipermail archives are always stored in the
         # private archive for the list.  This is safe because archives/private
@@ -93,7 +111,7 @@ class Archiver:
         omask = os.umask(0)
         try:
             try:
-                os.mkdir(self.archive_dir()+'.mbox', 02775)
+                os.makedirs(self.archive_dir()+'.mbox', 02775)
             except OSError, e:
                 if e.errno <> errno.EEXIST: raise
                 # We also create an empty pipermail archive directory into
@@ -101,7 +119,7 @@ class Archiver:
                 # that lists that have not yet received a posting have
                 # /something/ as their index.html, and don't just get a 404.
             try:
-                os.mkdir(self.archive_dir(), 02775)
+                os.makedirs(self.archive_dir(), 02775)
             except OSError, e:
                 if e.errno <> errno.EEXIST: raise
             # See if there's an index.html file there already and if not,
@@ -132,8 +150,7 @@ class Archiver:
 
     def ArchiveFileName(self):
         """The mbox name where messages are left for archive construction."""
-        return os.path.join(self.archive_dir() + '.mbox',
-                            self.internal_name() + '.mbox')
+        return Site.get_mboxpath(self.internal_name())
 
     def GetBaseArchiveURL(self):
         url = self.GetScriptURL('private', absolute=1) + '/'
@@ -143,7 +160,7 @@ class Archiver:
             hostname = re.match('[^:]*://([^/]*)/.*', url).group(1)\
                        or mm_cfg.DEFAULT_URL_HOST
             url = mm_cfg.PUBLIC_ARCHIVE_URL % {
-                'listname': self.internal_name(),
+                'listname': self.local_part,
                 'hostname': hostname
                 }
             if not url.endswith('/'):
diff -pru mailman-cvs-2.1-maint/Mailman/Archiver/HyperArch.py mailman-2.1.7.cg/Mailman/Archiver/HyperArch.py
--- mailman-cvs-2.1-maint/Mailman/Archiver/HyperArch.py	2006-01-29 06:12:26.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Archiver/HyperArch.py	2006-03-10 10:36:33.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -52,6 +52,7 @@ from Mailman import i18n
 from Mailman.SafeDict import SafeDict
 from Mailman.Logging.Syslog import syslog
 from Mailman.Mailbox import ArchiverMailbox
+from Mailman import Site
 
 # Set up i18n.  Assume the current language has already been set in the caller.
 _ = i18n._
@@ -304,7 +305,12 @@ class Article(pipermail.Article):
             if charset[0]=="'" and charset[-1]=="'":
                 charset = charset[1:-1]
             try:
-                body = message.get_payload(decode=True)
+                # Check Scrubber-munged payload
+                if message.get('x-mailman-scrubbed'):
+                    decode = False
+                else:
+                    decode = True
+                body = message.get_payload(decode=decode)
             except binascii.Error:
                 body = None
             if body and charset != Utils.GetCharSet(self._lang):
@@ -748,11 +754,11 @@ class HyperArchive(pipermail.T):
 
     def html_TOC(self):
         mlist = self.maillist
-        listname = mlist.internal_name()
-        mbox = os.path.join(mlist.archive_dir()+'.mbox', listname+'.mbox')
+        local_part = mlist.local_part
+        mbox = Site.get_mboxpath(mlist.internal_name())
         d = {"listname": mlist.real_name,
              "listinfo": mlist.GetScriptURL('listinfo', absolute=1),
-             "fullarch": '../%s.mbox/%s.mbox' % (listname, listname),
+             "fullarch": '../%s.mbox/%s.mbox' % (local_part, local_part), # NDIM XXX Path
              "size": sizeof(mbox, mlist.preferred_language),
              'meta': '',
              }
@@ -830,7 +836,7 @@ class HyperArchive(pipermail.T):
             return 1
         self._lock_file = LockFile.LockFile(
             os.path.join(mm_cfg.LOCK_DIR,
-                         self.maillist.internal_name() + '-arch.lock'))
+                         self.maillist.internal_name() + '-arch.lock')) # NDIM XXX Lock
         try:
             self._lock_file.lock(timeout=0.5)
         except LockFile.TimeOutError:
